Procedure SetPalette; ASSEMBLER;
Label Loop,Sync1,Sync2;
ASM
   PUSH ES
   PUSH AX
   PUSH BX
   PUSH CS
   PUSH DS
   Xor AL,AL
   Mov CX,768
   Mov SI,Offset _PALETTE
   Mov DX,03C8h
   Out DX,AL
   Inc DX
   Mov DX,03DAh
Sync1:
   In AL,DX
   Test AL,08h
   Jnz Sync1
Sync2:
   In AL,DX
   Test AL,08h
   Jz Sync2
   Mov BX,03C9h
   Mov DX,BX
Loop:
   Mov AL,[SI]
   Out DX,AL
   Dec CX
   Inc SI
   Cmp CX,0
   Jne Loop
   POP DS
   POP CX
   POP BX
   POP AX
   POP ES
END;

Procedure PaletteNaarBuffer;

Var WorkPalette : _PaletteArr;
    Reg         : Integer;
    CrossFade   : Integer;
Begin
  WorkPalette := _Palette;
  For CrossFade := 0 To 63 Do Begin
    For Reg := 0 To 255 Do Begin
      If (_Palette[Reg].Red > _PaletteBuffer[Reg].Red) Then Dec(_Palette[Reg].Red);
      If (_Palette[Reg].Green > _PaletteBuffer[Reg].Green) Then Dec(_Palette[Reg].Green);
      If (_Palette[Reg].Blue > _PaletteBuffer[Reg].Blue) Then Dec(_Palette[Reg].Blue);
    End;
    SetPalette;
  End;
  _PaletteBuffer := WorkPalette;
End;

Procedure BufferNaarPalette;

Var WorkPalette : _PaletteArr;
    Reg         : Integer;
    CrossFade   : Integer;
Begin
  WorkPalette := _Palette;
  For CrossFade := 0 To 63 Do Begin
    For Reg := 0 To 255 Do Begin
      If (_Palette[Reg].Red < _PaletteBuffer[Reg].Red) Then Inc(_Palette[Reg].Red);
      If (_Palette[Reg].Green < _PaletteBuffer[Reg].Green) Then Inc(_Palette[Reg].Green);
      If (_Palette[Reg].Blue < _PaletteBuffer[Reg].Blue) Then Inc(_Palette[Reg].Blue);
    End;
    SetPalette;
  End;
  _PaletteBuffer := WorkPalette;
End;
