Unit Screen;

INTERFACE

Uses Opslag;

Procedure BuildScreen(S : _ScrBuf_);
Function  GetScr(Y,X : Word) : Word;
Procedure PutScr(Y,X,S : Word);

IMPLEMENTATION

Uses Mode,Def;

Var  Gebruik : _ScrBuf_;

Procedure BuildScreen;
Var X,Y,I : Word;
    Use   : _SprBuf_;
Begin
  Gebruik := S;
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(1);
  Gems_Count := 0;

  {Beeld Opbouw}
  For Y := 0 To SCREEN_Y-1 Do Begin
    For X := 0 To SCREEN_X-1 Do Begin
      I := Gebruik[Y+1,X+1];
      If (I >= GEMS) Then Begin {Vaste Beelden}
        GetSprite(I,Use);
        TDraw_BitMap(Use,(X*SPRITE_X)+MOVE_X,(Y*SPRITE_Y)+MOVE_Y,SPRITE_X,SPRITE_Y);
        If (I >= GEMS) And (I < MUREN) Then Inc(Gems_Count);
      End;
    End;
  End;
  Copy_Page(0,1);
  Copy_Page(0,2);
  Set_Display_Page(0);
End;

Function GetScr(Y,X : Word) : Word;
Begin
  GetScr := Gebruik[Y,X];
End;

Procedure PutScr(Y,X,S : Word);
Begin
  Gebruik[Y,X] := S;
End;

End.