Function CheckDiskMan(Y,X : Byte) : Boolean;
Begin
  If (X = 0) Or
      (Y = 0) Or
       (X > 24) Or
        (Y > 14) Then CheckDiskMan := False Else
          CheckDiskMan := (X In [1..24]) And (Y In [1..14]) And
            (_HuidigeScreen.Buffer[Y,X] In _DOORLOPEN);
End;

Procedure ResetRichting(VAR AU : Boolean);
Begin
  _DiskLaatste := 0;
  AU := FALSE;
  If (LINKS = FALSE) AND (RECHTS = FALSE) AND
    (BOVEN = FALSE) AND (ONDER = FALSE) Then BufToDMan(_DMStil);
End;

Procedure AnimatieBovenOnder;
Begin
  If _LinksRechts = _DM_Rechts Then
    If (_Animatie=0) Then BufToDMan(_DMRechts1) Else BufToDMan(_DMRechts2)
  Else If (_Animatie=0) Then BufToDMan(_DMLinks1) Else BufToDMan(_DMLinks2);
End;


Procedure Init_Links;
Var I : Byte;
Begin
  _LinksRechts := _DM_Links;
  _DiskLaatste := _DM_Links;
  _DiskManBits := 0;
  RECHTS := False;
  BOVEN := False;
  ONDER := False;
  Move(_SpriteRec[_DMLinks1]^,_DiskMan.Buffer,SizeOf(_SpriteRec[_DMLinks1]^));
End;

Procedure Init_Rechts;
Var I : Byte;
Begin
  _LinksRechts := _DM_Rechts;
  _DiskLaatste := _DM_Rechts;
  _DiskManBits := 0;
  LINKS := False;
  BOVEN := False;
  ONDER := False;
  Move(_SpriteRec[_DMRechts1]^,_DiskMan.Buffer,SizeOf(_SpriteRec[_DMRechts1]^));
End;

Procedure Init_Boven;
Begin
  _DiskLaatste := _DM_Boven;
  _DiskManBits := 0;
  LINKS := False;
  RECHTS := False;
  ONDER := False;
End;

Procedure Init_Onder;
Begin
  _DiskLaatste := _DM_Onder;
  _DiskManBits := 0;
  LINKS := False;
  RECHTS := False;
  BOVEN := False;
End;

Procedure HaalWeg(Y,X : Byte);
Var I        : Integer;
Begin
  If (_DiskManBits = 0) Then Begin
    If (_HuidigeScreen.Buffer[Y,X] In [71,72]) Then Begin
      Set_Active_Page(2);
      Draw_Bitmap(_SpriteRec[_Leeg]^.Buffer,(X*15)-15+_XPos,(Y*15)-15+_YPos,15,15);
      Set_Active_Page(_CurrentPage);
      {Dec(AllesOpGegeten);}
      _HuidigeScreen.Buffer[Y,X] := 0;
    End;
  End;
End;

Procedure BeweegDiskMan;
Var I,W       : Byte;
    DoodCheck : Byte;
    YCheck,
    XCheck    : Byte;
Begin
    HaalWeg(_DiskMan.YRow,_DiskMan.XRow);
    If ((LINKS = TRUE) And (_DiskManBits = 0)) Or (_DiskLaatste = _DM_Links) Then Begin
       If CheckDiskMan(_DiskMan.YRow,_DiskMan.XRow-1) Then Begin
         If _DiskLaatste <> _DM_Links Then Init_Links;
         Dec(_DiskMan.XPos,BITS);
         Inc(_DiskManBits,BITS);
         If (_DiskManBits = 15) Then Begin
           _DiskManBits := 0;
           Dec(_DiskMan.XRow,1);
         End;
         If (_Animatie=0) Then BufToDMan(_DMLinks1) Else BufToDMan(_DMLinks2);
       End Else ResetRichting(LINKS);
    End;

    HaalWeg(_DiskMan.YRow,_DiskMan.XRow);
    If ((RECHTS = TRUE) And (_DiskManBits = 0)) Or (_DiskLaatste = _DM_Rechts) Then Begin
       If CheckDiskMan(_DiskMan.YRow,_DiskMan.XRow+1) Then Begin
         If _DiskLaatste <> _DM_Rechts Then Init_Rechts;
         Inc(_DiskMan.XPos,BITS);
         Inc(_DiskManBits,BITS);
         If (_DiskManBits = 15) Then Begin
           _DiskManBits := 0;
           Inc(_DiskMan.XRow);
         End;
         If (_Animatie=0) Then BufToDMan(_DMRechts1) Else BufToDMan(_DMRechts2);
       End Else ResetRichting(RECHTS);
    End;

    HaalWeg(_DiskMan.YRow,_DiskMan.XRow);
    If ((ONDER = TRUE) And (_DiskManBits = 0)) Or (_DiskLaatste = _DM_Onder) Then Begin
       If CheckDiskMan(_DiskMan.YRow+1,_DiskMan.XRow) Then Begin
         If _DiskLaatste <> _DM_Onder Then Init_Onder;
         Inc(_DiskMan.YPos,BITS);
         Inc(_DiskManBits,BITS);
         If (_DiskManBits = 15) Then Begin
           _DiskManBits := 0;
           Inc(_DiskMan.YRow);
         End;
         AnimatieBovenOnder;
       End Else ResetRichting(ONDER);
    End;

    HaalWeg(_DiskMan.YRow,_DiskMan.XRow);
    If ((BOVEN = TRUE) And (_DiskManBits = 0)) Or (_DiskLaatste = _DM_Boven) Then Begin
       If CheckDiskMan(_DiskMan.YRow-1,_DiskMan.XRow) Then Begin
         If _DiskLaatste <> _DM_Boven Then Init_Boven;
         Dec(_DiskMan.YPos,BITS);
         Inc(_DiskManBits,BITS);
         If (_DiskManBits = 15) Then Begin
           _DiskManBits := 0;
           Dec(_DiskMan.YRow,1);
         End;
         AnimatieBovenOnder;
       End Else ResetRichting(BOVEN);
    End;
    {CheckLetter(DiskMan.YRow,DiskMan.XRow);}

    {ANIMATIE DISKMAN EN VIJAND}
    If _TijdTeller > 3 Then Begin
      _Animatie := (_Animatie+1) MOD 2;
      _TijdTeller := 0;
    End;

End;
