Function CheckVijand(W,Y,X : Byte) : Boolean;
Begin
  CheckVijand := (X In [2..XVELD-1]) And (Y In [2..YVELD-1]) And
      (_HuidigeScreen.Buffer[Y,X] In _DOORLOPEN);
End;

Function IMM : Boolean;
Begin
  IMM := RANDOM(IMMFactor) = 0;
End;

Function BovenOfOnder(W : Byte) : Byte;
Begin
  If IMM Then Begin
    If (_Vijand.YRow > _DiskMan.YRow) Then
      BovenOfOnder := _DM_Boven Else BovenOfOnder := _DM_Onder;
  End Else
    If RANDOM(2) = 0 Then BovenOfOnder := _DM_Onder Else BovenOfOnder := _DM_Boven;
End;

Function LinksOfRechts(W : Byte) : Byte;
Begin
  If IMM Then Begin
    If (_Vijand.XRow > _DiskMan.XRow) Then
      LinksOfRechts := _DM_Links Else LinksOfRechts := _DM_Rechts;
  End Else
    If RANDOM(2) = 0 Then LinksOfRechts := _DM_Links Else LinksOfRechts := _DM_Rechts;
End;

Procedure BerekenDIR(W,X,Y : Byte);
Var DD : Byte;
Begin
  CASE Kijk[W] Of
      _DM_Boven,_DM_Onder :
      Begin
        If (CheckVijand(W,Y-1,X) And (Kijk[W] = _DM_Boven)) Or
          (CheckVijand(W,Y+1,X) And (Kijk[W] = _DM_Onder)) Then
        Begin
          DD := LinksOfRechts(W);
          If (CheckVijand(W,Y,X-1) And (DD = _DM_Links)) Then Kijk[W] := _DM_Links
          Else If (CheckVijand(W,Y,X+1) And (DD = _DM_Rechts)) Then Kijk[W] := _DM_Rechts;
        End Else Begin
          If (CheckVijand(W,Y,X-1) And CheckVijand(W,Y,X+1)) Then Kijk[W] := LinksOfRechts(W)
          Else If CheckVijand(W,Y,X-1) Then Kijk[W] := _DM_Links
          Else If CheckVijand(W,Y,X+1) Then Kijk[W] := _DM_Rechts
          Else If Kijk[W] = _DM_Boven Then Kijk[W] := _DM_Onder Else Kijk[W] := _DM_Boven;
        End
      End;
      _DM_Links,_DM_Rechts :
      Begin
        If (CheckVijand(W,Y,X+1) And (Kijk[W] = _DM_Rechts)) Or
          (CheckVijand(W,Y,X-1) And (Kijk[W] = _DM_Links)) Then
        Begin
          DD := BovenOfOnder(W);
          If (CheckVijand(W,Y-1,X) And (DD = _DM_Boven)) Then Kijk[W] := _DM_Boven
          Else If (CheckVijand(W,Y+1,X) And (DD = _DM_Onder)) Then Kijk[W] := _DM_Onder;
        End Else Begin
          If (CheckVijand(W,Y-1,X) And CheckVijand(W,Y+1,X)) Then Kijk[W] := BovenOfOnder(W)
          Else If CheckVijand(W,Y-1,X) Then Kijk[W] := _DM_Boven
          Else If CheckVijand(W,Y+1,X) Then Kijk[W] := _DM_Onder
          Else If Kijk[W] = _DM_Rechts Then Kijk[W] := _DM_Links Else Kijk[W] := _DM_Rechts;
        End
      End
    ELSE
      If CheckVijand(W,Y,X-1) Then Kijk[W] := _DM_Links Else
       If CheckVijand(W,Y,X+1) Then Kijk[W] := _DM_Rechts Else
        If CheckVijand(W,Y-1,X) Then Kijk[W] := _DM_Boven Else
         If CheckVijand(W,Y+1,X) Then Kijk[W] := _DM_Onder Else
          Kijk[W] := 0;
  END;
End;

Procedure Beweeg_Alien(W : Byte);
Var DoodCheck : Byte;
Begin

  If (Kijk[W] = _DM_Links) Then Begin
    If _AlienLaatste[W] <> _DM_Links Then Begin
      _AlienLaatste[W] := _DM_Links;
      _AlienLOrR[W]:= _DM_Links;
      _AlienBits[W] := 0;
    End;
    Dec(_Vijand.XPos,BITS);
    Inc(_AlienBits[W],BITS);
    If (_AlienBits[W] = BREEDTE) Then Begin
      _AlienBits[W] := 0;
      Dec(_Vijand.XRow,1);
    End;
  End;

  If (Kijk[W] = _DM_Rechts) Then Begin
    If _AlienLaatste[W] <> _DM_Rechts Then Begin
      _AlienLaatste[W] := _DM_Rechts;
      _AlienLOrR[W] := _DM_Rechts;
      _AlienBits[W] := 0;
    End;
    Inc(_Vijand.XPos,BITS);
    Inc(_AlienBits[W],BITS);
    If (_AlienBits[W] = BREEDTE) Then Begin
      _AlienBits[W] := 0;
      Inc(_Vijand.XRow,1);
    End;
  End;

  If (Kijk[W] = _DM_Onder) Then Begin
    If _AlienLaatste[W] <> _DM_Onder Then Begin
      _AlienLaatste[W] := _DM_Onder;
      _AlienBits[W] := 0;
    End;
    Inc(_Vijand.YPos,BITS);
    Inc(_AlienBits[W],BITS);
    If (_AlienBits[W] = BREEDTE) Then Begin
      _AlienBits[W] := 0;
      Inc(_Vijand.YRow,1);
    End;
  End;

  If (Kijk[W] = _DM_Boven) Then Begin
    If _AlienLaatste[W] <> _DM_Boven Then Begin
      _AlienLaatste[W] := _DM_Boven;
      _AlienBits[W] := 0;
    End;
    Dec(_Vijand.YPos,BITS);
    Inc(_AlienBits[W],BITS);
    If (_AlienBits[W] = BREEDTE) Then Begin
      _AlienBits[W] := 0;
      Dec(_Vijand.YRow,1);
    End;
  End;

  If (_AlienBits[1] = 0) Then BerekenDIR(1,_Vijand.XRow,_Vijand.YRow);
End;

Procedure BeweegVijand;
Var I : Byte;
Begin
 { For I := 1 To VijandAantal Do If VijandTrue[I] Then Beweeg_Alien(I);}
 If _Vijand.Active Then Beweeg_Alien(1);

End;
