Unit Palette;

INTERFACE

Type _PaletteRec = RECORD
        Red   : Byte;
        Green : Byte;
        Blue  : Byte;
     END;
     _PaletteArr = Array[0..255] Of _PaletteRec;

Var  _Palette : _PaletteArr;

Procedure ReadPalette;

IMPLEMENTATION

Procedure SetPalette; ASSEMBLER;
Label Loop,Sync1,Sync2;
ASM
   PUSH ES
   PUSH AX
   PUSH BX
   PUSH CS
   PUSH DS
   Xor AL,AL
   Mov CX,768
   Mov SI,Offset _PALETTE
   Mov DX,03C8h
   Out DX,AL
   Inc DX
   Mov DX,03DAh
Sync1:
   In AL,DX
   Test AL,08h
   Jnz Sync1
Sync2:
   In AL,DX
   Test AL,08h
   Jz Sync2
   Mov BX,03C9h
   Mov DX,BX
Loop:
   Mov AL,[SI]
   Out DX,AL
   Dec CX
   Inc SI
   Cmp CX,0
   Jne Loop
   POP DS
   POP CX
   POP BX
   POP AX
   POP ES
END;

Procedure ReadPalette;
Var T       : Byte;
    F       : File;
Begin
  Assign(F,'PRIME.PAL');
  Reset(F,1);
  BlockRead(F,_Palette,SizeOf(_Palette));
  Close(F);
  SetPalette;
End;

End.